VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Begin VB.Form frmBCFD 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "BCFD"
   ClientHeight    =   4650
   ClientLeft      =   345
   ClientTop       =   735
   ClientWidth     =   6195
   Icon            =   "frmBCFD.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4650
   ScaleWidth      =   6195
   StartUpPosition =   2  'CenterScreen
   WhatsThisHelp   =   -1  'True
   Begin VB.CheckBox chkExcel 
      Caption         =   "Write to Excel file"
      Height          =   255
      Left            =   480
      TabIndex        =   1
      Top             =   1320
      Value           =   1  'Checked
      Width           =   1575
   End
   Begin VB.CommandButton cmdStart 
      Caption         =   "Start"
      Enabled         =   0   'False
      Height          =   375
      Left            =   480
      TabIndex        =   2
      Top             =   1920
      Width           =   1575
   End
   Begin MSComctlLib.ProgressBar ProgBarCount 
      Height          =   255
      Left            =   960
      TabIndex        =   7
      Top             =   4200
      Width           =   1575
      _ExtentX        =   2778
      _ExtentY        =   450
      _Version        =   393216
      Appearance      =   1
   End
   Begin VB.CommandButton cmdAbout 
      Caption         =   "About"
      Height          =   375
      Left            =   480
      TabIndex        =   3
      Top             =   2760
      Width           =   735
   End
   Begin MSComctlLib.ProgressBar ProgBarLoad 
      Height          =   255
      Left            =   960
      TabIndex        =   6
      Top             =   3840
      Width           =   1575
      _ExtentX        =   2778
      _ExtentY        =   450
      _Version        =   393216
      Appearance      =   1
   End
   Begin VB.TextBox txtOut 
      Height          =   4335
      Left            =   2640
      MultiLine       =   -1  'True
      TabIndex        =   5
      Top             =   120
      Width           =   3375
   End
   Begin VB.CommandButton cmdQuit 
      Caption         =   "Quit"
      Height          =   375
      Left            =   1320
      TabIndex        =   4
      Top             =   2760
      Width           =   735
   End
   Begin VB.CommandButton cmdOpen 
      Caption         =   "Open file"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   238
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   480
      TabIndex        =   0
      Top             =   840
      Width           =   1575
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   2160
      Top             =   120
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Label lblProgram 
      Caption         =   "BCFD"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   12
         Charset         =   238
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   120
      TabIndex        =   10
      Top             =   120
      Width           =   2415
   End
   Begin VB.Label lblProgressCount 
      Alignment       =   1  'Right Justify
      Caption         =   "Calculated"
      Height          =   255
      Left            =   0
      TabIndex        =   9
      Top             =   4200
      Width           =   855
   End
   Begin VB.Label lblProgressLoad 
      Alignment       =   1  'Right Justify
      Caption         =   "Loaded"
      Height          =   255
      Left            =   0
      TabIndex        =   8
      Top             =   3840
      Width           =   855
   End
End
Attribute VB_Name = "frmBCFD"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' BCFD - a Visual Basic program for box-counting calculation of the fractal dimension
'
' Timotej Verbovek
' University of Ljubljana, Faculty of Natural Sciences and Engineering, Department of Geology
'
' More information is available in the article _______


Option Base 1
Option Explicit

Dim B As Byte 'Definition and dimensioning of the variables
Dim M As Byte
Dim bpp As Byte
Dim ind1 As Byte
Dim ind2 As Byte
Dim ind3 As Byte
Dim ind4 As Byte
Dim blank As Byte
Dim pixel() As Byte
Dim ExcelRows As Byte
Dim InputByte As Byte
Dim Iterations As Byte
Dim bit As Single
Dim offset As Single
Dim NN, NNexp As Single
Dim D, R2 As Single
Dim xi() As Single
Dim yi() As Single
Dim difx2() As Single
Dim dify2() As Single
Dim difxdify() As Single
Dim i, a, xx, yy As Single
Dim CountOne() As Single
Dim CountTot() As Single
Dim BMPwidth, BMPheight As Single
Dim sumx, sumy, avgx, avgy As Single
Dim yy1, xx1, ybox, xbox, Box_Size As Single
Dim sumdifx2, sumdify2, sumdifxdify As Single
Dim ExcelActive As Boolean
Dim ResultFiles As String
Dim objExcel As Object


Private Sub Form_Load() 'Events after the startup of the programme
    frmBCFD.Show
    txtOut.Text = "Results window" & vbNewLine
    frmBCFD.Caption = "BCFD - Waiting to open BMP file"
    cmdStart.Enabled = False
End Sub

Private Sub cmdOpen_Click() 'Event for the Open button
    If chkExcel.Value = Checked Then
        InitializeExcel
        ExcelActive = True
        frmBCFD.SetFocus
    End If
    
    CommonDialog1.InitDir = "."
    CommonDialog1.Filter = "1-bit BMP files (*.bmp)|*.bmp"
    CommonDialog1.ShowOpen
    
    Call PictureInfo
    txtOut.Text = "Image file name: " & CommonDialog1.FileTitle & vbNewLine & _
                  "Resolution: " & BMPwidth & "x" & BMPheight & vbNewLine & _
                  "Color depth: " & bpp & "bits" & vbNewLine & vbNewLine & _
                  "Image OK, press Start to load and calculate."
        
    chkExcel.Enabled = False
    cmdOpen.Enabled = False
    cmdOpen.FontBold = False
    cmdStart.Enabled = True
    cmdStart.FontBold = True
    cmdStart.SetFocus
    frmBCFD.Caption = "BCFD - Waiting to start calculations"
        
    If CommonDialog1.FileName = "" Then
        cmdOpen.Enabled = True
        cmdOpen.FontBold = True
        cmdOpen.SetFocus
        cmdStart.Enabled = False
        cmdStart.FontBold = False
        txtOut.Text = "No file selected, please try again"
        frmBCFD.Caption = "BCFD - Please select file"
    End If
End Sub

Private Sub cmdStart_click()  'Event for the Start button
    txtOut.Text = "Loading and calculating..."
    cmdOpen.Enabled = False
    cmdStart.Enabled = False
    cmdAbout.Enabled = False
    cmdQuit.Enabled = False
        
    Call ReadFileIntoArray
  
    ProgBarCount.Min = 0
    ProgBarCount.Max = Log(Val(BMPwidth)) / Log(2)
    ProgBarCount.Scrolling = ccScrollingStandard
    txtOut.Text = "Box size (s)" & vbTab & "Box count (N(s))" & vbNewLine
    
    For NN = Log(Val(BMPwidth)) / Log(2) To 0 Step -1
        NNexp = 2 ^ NN
        frmBCFD.Caption = "Counting box size " & NNexp
        ProgBarCount.Value = Log(Val(BMPwidth)) / Log(2) - NN
        CountBoxes (NNexp)
    Next NN
    
    Call D_and_R2
    
    If chkExcel.Value = Checked Then
        ResultFiles = " " & Left(CommonDialog1.FileTitle, Len(CommonDialog1.FileTitle) - 4) & ".txt and" & vbNewLine & _
        " " & Left(CommonDialog1.FileTitle, Len(CommonDialog1.FileTitle) - 4) & ".xls"
    Else
        ResultFiles = " " & Left(CommonDialog1.FileTitle, Len(CommonDialog1.FileTitle) - 4) & ".txt"
    End If
    
    txtOut.Text = txtOut.Text & vbNewLine & "D = " & FormatNumber(D, 4)
    txtOut.Text = txtOut.Text & vbNewLine & "R2 = " & FormatNumber(R2, 4) & vbNewLine
    txtOut.Text = txtOut.Text & vbNewLine & "Results written to files:" & vbNewLine & ResultFiles

    Call WriteToTextfile
    If chkExcel.Value = Checked Then
        Call WriteToExcelFile
    End If
    
    frmBCFD.Caption = "BCFD (" & CommonDialog1.FileTitle & ") - finished!"
    cmdStart.FontBold = False
    cmdOpen.Enabled = True
    cmdAbout.Enabled = True
    cmdQuit.Enabled = True
    cmdQuit.FontBold = True
    cmdQuit.SetFocus
End Sub
  
Private Sub cmdAbout_Click() 'Event for the About button
    frmAbout.Show
End Sub

Private Sub cmdQuit_Click() 'Event for the Quit button
    If chkExcel.Value = Checked And ExcelActive = True Then
        objExcel.application.Quit
        Set objExcel = Nothing
    End If
    End
End Sub

Sub PictureInfo() 'Check the image information
    If CommonDialog1.FileName = "" Then Exit Sub
    Open CommonDialog1.FileName For Binary As #1

    Call CheckForBMP
    Call Void(8)
    offset = Hex4Bytes()
    Call Void(4)
    Call CheckResolution
    Call Void(2)
    Call CheckColorDepth
    
    Close #1
End Sub
    
Sub CheckForBMP() 'Check if the file is in the BMP format
    Get #1, , B
    Get #1, , M
    If B <> 66 Or M <> 77 Then MsgBox ("Not an BMP format!"): End
End Sub

Sub CheckResolution() 'Check if the resolution is OK
    BMPwidth = Hex4Bytes()
    BMPheight = Hex4Bytes()
    
    ReDim pixel(BMPwidth, BMPheight) As Byte
    ReDim CountOne(BMPwidth) As Single
    ReDim CountTot(BMPwidth) As Single

    Select Case BMPwidth
        Case 4096, 2048, 1024, 512, 256 'Change, add or remove resolutions here if necessary
        Case Else
            MsgBox ("Image width and height should be 256, 512, 1024, 2048 or 4096 pixels!")
            End
    End Select
    
    If BMPwidth <> BMPheight Then
        MsgBox ("Image X ynd Y resolution should be the same")
        End
    End If
End Sub

Sub CheckColorDepth() 'Check if the image is 1-bit monochrome BMP
    Get #1, , bpp
    If bpp <> 1 Then MsgBox ("Not a 1-bit BMP format!"): End
End Sub

Function Hex4Bytes() As Double 'Convert four hexadecimal bytes into decimal number
     Get #1, , ind1
     Get #1, , ind2
     Get #1, , ind3
     Get #1, , ind4
     Hex4Bytes = ind1 + 256 * ind2 + 256 ^ 2 * ind3 + 256 ^ 3 * ind4
End Function

Function Void(a As Integer) As Integer 'Read non-usable bytes
    For i = 1 To a
        Get #1, , blank
    Next i
End Function

Sub ReadFileIntoArray() 'Read file bytes into virtual image array by converting each image byte into 8 bits
    Open CommonDialog1.FileName For Binary As #1
    frmBCFD.Caption = "Loading..."
    
    Void (offset)
    ProgBarLoad.Min = 1
    ProgBarLoad.Max = BMPwidth
    ProgBarLoad.Value = 1
    ProgBarLoad.Scrolling = ccScrollingSmooth
    
    For yy = 1 To BMPwidth
        For xx = 0 To (BMPwidth / 8) - 1
            bit = 0
            Get #1, , InputByte
                For NN = 1 To 8
                    If (InputByte And 2 ^ (8 - NN)) = 2 ^ (8 - NN) Then
                        bit = bit + 1
                        pixel(xx * 8 + NN, yy) = 1
                    Else
                        pixel(xx * 8 + NN, yy) = 0
                    End If
                Next NN
        Next xx
    ProgBarLoad.Value = yy
    Next yy
    
    Close #1
End Sub

Function CountBoxes(Box_Size As Single) As Single 'Main code for the box-counting algorithm
    CountTot(Box_Size) = 0
    For yy1 = 0 To (BMPwidth / Box_Size) - 1
        For xx1 = 0 To (BMPwidth / Box_Size) - 1
            CountOne(Box_Size) = 0
            For ybox = 1 To Box_Size
                For xbox = 1 To Box_Size
                    If pixel(xx1 * Box_Size + xbox, yy1 * Box_Size + ybox) = 1 Then CountOne(Box_Size) = 1
                Next xbox
            Next ybox
        CountTot(Box_Size) = CountTot(Box_Size) + CountOne(Box_Size)
        Next xx1
    Next yy1
    txtOut.Text = txtOut.Text & (Str(Box_Size) & vbTab & vbTab & Str(CountTot(Box_Size))) & vbNewLine
End Function

Sub WriteToTextfile() 'Write results into text file
    Open Left(CommonDialog1.FileName, Len(CommonDialog1.FileName) - 4) & ".txt" For Output As #3
    Print #3, "Box size (s): Box count (N(s))"
    For NN = Log(Val(BMPwidth)) / Log(2) To 0 Step -1
        NNexp = 2 ^ NN
        Print #3, NNexp & ":" & CountTot(NNexp)
    Next NN
    Print #3,
    Print #3, "D  = " & FormatNumber(D, 4)
    Print #3, "R2 = " & FormatNumber(R2, 4)
    Close #3
End Sub
    
Sub WriteToExcelFile() 'Write results into MS Excel file
    ExcelRows = Log(Val(BMPwidth)) / Log(2) + 2
    For NN = Log(Val(BMPwidth)) / Log(2) To 0 Step -1
        NNexp = 2 ^ NN
        objExcel.application.Cells(14 - NN, 1).Value = NNexp
        objExcel.application.Cells(14 - NN, 2).Value = CountTot(NNexp)
        objExcel.application.Cells(14 - NN, 3).Value = Log(NNexp)
        objExcel.application.Cells(14 - NN, 4).Value = Log(CountTot(NNexp))
    Next NN

    objExcel.application.Worksheets("Sheet1").Name = Left(CommonDialog1.FileTitle, Len(CommonDialog1.FileTitle) - 4)
    objExcel.application.Cells(16, 4).formula = "=-SLOPE(D2:D14,C2:C14)"
    objExcel.application.Cells(16, 4).Font.Bold = True
    objExcel.application.Cells(17, 4).formula = "=RSQ(D2:D14,C2:C14)"
    objExcel.application.Cells(17, 4).Font.Bold = True
    objExcel.application.Cells(16, 5).Value = "Fractal dimension (D)"
    objExcel.application.Cells(16, 5).Font.Bold = True
    objExcel.application.Cells(17, 5).Value = "Correlation coefficient (R-squared)"
    objExcel.application.Cells(17, 5).Font.Bold = True
    
    objExcel.SaveAs Left(CommonDialog1.FileName, Len(CommonDialog1.FileName) - 4) & ".xls"
End Sub

Sub InitializeExcel() 'Start MS Excel with BCFD if the checkbox is marked
    Set objExcel = CreateObject("Excel.sheet")
    objExcel.application.Visible = True
    objExcel.application.Cells(1, 1).Value = "Box size (s)"
    objExcel.application.Cells(1, 1).Font.Bold = True
    objExcel.application.Cells(1, 2).Value = "Box count (N(s))"
    objExcel.application.Cells(1, 2).Font.Bold = True
    objExcel.application.Cells(1, 3).Value = "Log(s)"
    objExcel.application.Cells(1, 3).Font.Bold = True
    objExcel.application.Cells(1, 4).Value = "Log(N(s))"
    objExcel.application.Cells(1, 4).Font.Bold = True
End Sub

Sub D_and_R2() 'Calculation of fractal dimension (D) and squared value of Pearson's correlation coefficient (R2)

Iterations = Log(Val(BMPwidth)) / Log(2)

ReDim xi(Iterations + 1)
ReDim yi(Iterations + 1)
ReDim difx2(Iterations + 1)
ReDim dify2(Iterations + 1)
ReDim difxdify(Iterations + 1)

For NN = Iterations To 0 Step -1
    NNexp = 2 ^ NN
    xi(NN + 1) = Log(NNexp)
    yi(NN + 1) = Log(CountTot(NNexp))
    sumx = sumx + xi(NN + 1)
    sumy = sumy + yi(NN + 1)
Next NN

avgx = sumx / (Iterations + 1)
avgy = sumy / (Iterations + 1)

For NN = Iterations To 0 Step -1
    difx2(NN + 1) = (xi(NN + 1) - avgx) ^ 2
    dify2(NN + 1) = (yi(NN + 1) - avgy) ^ 2
    difxdify(NN + 1) = (xi(NN + 1) - avgx) * (yi(NN + 1) - avgy)
    sumdifx2 = sumdifx2 + difx2(NN + 1)
    sumdify2 = sumdify2 + dify2(NN + 1)
    sumdifxdify = sumdifxdify + difxdify(NN + 1)
Next NN

D = -sumdifxdify / sumdifx2
If sumdifx2 * sumdify2 = 0 Then 'Return the value of -9.9999 for R2 to avoid dividing by zero
    R2 = -9.9999
Else
    R2 = (sumdifxdify / Sqr(sumdifx2 * sumdify2)) ^ 2
End If

End Sub

